/* Estrelas. Usa vetores com FOR. 

Compile com Turbo C

Contatos:
lebe@aton.inf.ufrgs.br
lebe@geocities.com

Visite:
www.geocities.com/SiliconValley/Bay/1704
*/


#include <graphics.h>
#include <conio.h>                   // necessario para getch ()
#include <math.h>                    // M_PI, cos, sin, ...


/* Retorna a parte fracionaria de um numero do tipo DOUBLE.
****************************************************************************/
inline double Frac ( double Numero )
{
   long
      NInteiro = ( long ) Numero;

   return ( (double) Numero - NInteiro );
}



/* Traca um vetor
****************************************************************************/
void Vetor ( int Angulo, int Comprimento )
{
   static int
      SomaAngs = 0;

   SomaAngs = ( SomaAngs + Angulo ) % 360;

   double
      Radianos = (double) ( SomaAngs * (double) ( M_PI / 180 ) ),
      Base = (double) ( cos ( Radianos ) * Comprimento + (double) Frac ( Base ) ),
      Altura = (double) ( - sin ( Radianos ) * Comprimento + (double) Frac ( Altura ) );

   linerel ( (int) Base, (int) Altura );
}



/* Desenha estrela.
****************************************************************************/
void Faz_Estrela ( int nC, int nI2, int nP1, int nP2, int nP3, int nL1 )
{
   moveto ( getmaxx () / 2, getmaxy () / 2 );

   for (int Conta1 = 1; Conta1 <= nL1; Conta1 += nP1)
      for (int Conta2 = Conta1 + nI2; Conta2 <= 360 + Conta1; Conta2 += nP2)
         for (int Conta3 = Conta2 + 1; Conta3 <= 360 + Conta2; Conta3 += nP3)
            Vetor (Conta3 + 180, nC);
}


main ()
{
   int
      GrDriver = DETECT,
      GrMode;

   initgraph (&GrDriver, &GrMode, "");

   Faz_Estrela ( 4, 1, 10, 10, 100, 1800 );
   getch ();
   cleardevice ();

   Faz_Estrela ( 2, 2, 12, 13, 110, 3000 );
   getch ();
   cleardevice ();

   Faz_Estrela ( 3, 2, 12, 14, 110, 5000 );
   getch ();
   cleardevice ();

   Faz_Estrela ( 1, 1, 15, 14, 10, 2000 );
   getch ();
   cleardevice ();

   Faz_Estrela ( 1, 2, 15, 14, 10, 2000 );
   getch ();
   cleardevice ();

   closegraph ();
}
